/*
 * generated by Fujaba - CodeGen2
 */
package de.uks.pmss11.wizard;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class Card
{



   public static final String PROPERTY_COLOR = "color";

   @Property( name = PROPERTY_COLOR, kind = ReferenceHandler.ReferenceKind.ATTRIBUTE )
   private String color;

   @Property( name = PROPERTY_COLOR )
   public void setColor (String value)
   {
      this.color = value;
   }

   public Card withColor (String value)
   {
      setColor (value);
      return this;
   }

   @Property( name = PROPERTY_COLOR )
   public String getColor ()
   {
      return this.color;
   }

   /**
    * <pre>
    *           0..n     cards     0..1
    * Card ------------------------- Player
    *           cards               player
    * </pre>
    */
   public static final String PROPERTY_PLAYER = "player";

   @Property( name = PROPERTY_PLAYER, partner = Player.PROPERTY_CARDS, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Player player;

   @Property( name = PROPERTY_PLAYER )
   public boolean setPlayer (Player value)
   {
      boolean changed = false;

      if (this.player != value)
      {
      
         Player oldValue = this.player;
         Card source = this;
         if (this.player != null)
         {
            this.player = null;
            oldValue.removeFromCards (this);
         }
         this.player = value;

         if (value != null)
         {
            value.addToCards (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_PLAYER )
   public Card withPlayer (Player value)
   {
      setPlayer (value);
      return this;
   }

   public Player getPlayer ()
   {
      return this.player;
   }

   /**
    * <pre>
    *           0..n     cards     0..1
    * Card ------------------------- Stack
    *           cards               stack
    * </pre>
    */
   public static final String PROPERTY_STACK = "stack";

   @Property( name = PROPERTY_STACK, partner = Stack.PROPERTY_CARDS, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Stack stack;

   @Property( name = PROPERTY_STACK )
   public boolean setStack (Stack value)
   {
      boolean changed = false;

      if (this.stack != value)
      {
      
         Stack oldValue = this.stack;
         Card source = this;
         if (this.stack != null)
         {
            this.stack = null;
            oldValue.removeFromCards (this);
         }
         this.stack = value;

         if (value != null)
         {
            value.addToCards (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_STACK )
   public Card withStack (Stack value)
   {
      setStack (value);
      return this;
   }

   public Stack getStack ()
   {
      return this.stack;
   }

   /**
    * <pre>
    *           0..n     cards     0..n
    * Card ------------------------- Trick
    *           cards               tricks
    * </pre>
    */
   public static final String PROPERTY_TRICKS = "tricks";

   @Property( name = PROPERTY_TRICKS, partner = Trick.PROPERTY_CARDS, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FLinkedList<Trick> tricks;

   @Property( name = PROPERTY_TRICKS )
   public List<? extends Trick> getTricks()
   {
      return ((this.tricks == null)
              ? Collections.EMPTY_LIST
              : Collections.unmodifiableList(this.tricks));
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean addToTricks (Trick value)
   {
      boolean changed = false;

      if (value != null && !this.hasInTricks (value))
      {
         if (this.tricks == null)
         {
            this.tricks = new FLinkedList<Trick> ();

         }
      
         changed = this.tricks.add (value);
         if (changed)
         {
            value.addToCards (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TRICKS )
   public Card withTricks (Trick value)
   {
      addToTricks (value);
      return this;
   }

   public Card withoutTricks (Trick value)
   {
      removeFromTricks (value);
      return this;
   }


   public boolean removeFromTricks (Trick value)
   {
      boolean changed = false;

      if ((this.tricks != null) && (value != null))
      {
      
         changed = this.tricks.remove (value);
         if (changed)
         {
            value.removeFromCards (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TRICKS )
   public void removeAllFromTricks (){
   
      Trick tmpValue;
      Iterator<? extends Trick> iter = this.iteratorOfTricks ();
      while (iter.hasNext ())
      {
         tmpValue = (Trick) iter.next ();
         this.removeFromTricks (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean hasInTricks (Trick value)
   {
      return ((this.tricks != null) &&
              (value != null) &&
              this.tricks.contains (value));
   }

   @Property( name = PROPERTY_TRICKS )
   public ListIterator<? extends Trick> iteratorOfTricks ()
   {
      return ((this.tricks == null)
              ? FEmptyListIterator.<Trick>get ()
              : this.tricks.listIterator());
   }

   @Property( name = PROPERTY_TRICKS )
   public int sizeOfTricks ()
   {
      return ((this.tricks == null)
              ? 0
              : this.tricks.size ());
   }
   @Property( name = PROPERTY_TRICKS )
   public Trick getFirstOfTricks ()
   {
      if (tricks == null)
      {
         return null;
      }
      else
      {
         if (tricks.size() == 0) 	 
         { 	 
            return null; 	 
         }
         return (Trick) tricks.getFirst ();
      }
   }

   @Property( name = PROPERTY_TRICKS )
   public Trick getLastOfTricks ()
   {
      if (tricks == null)
      {
         return null;
      }
      else
      {
         if (tricks.size() == 0) 	 
         { 	 
            return null; 	 
         }
         return (Trick) tricks.getLast ();
      }
   }
   @Property( name = PROPERTY_TRICKS )
   public Trick getFromTricks ( int index )
   {
      if (index >= 0 && index < sizeOfTricks ())
      {
         return (Trick) this.tricks.get (index);
      }
      else
      {
         throw new IllegalArgumentException ("getTricksAt(" + index + ")" );
      }
   }

   @Property( name = PROPERTY_TRICKS )
   public int indexOfTricks ( Trick value )
   {
      return ((this.tricks == null)
              ? -1
              : this.tricks.indexOf (value));
   }

   @Property( name = PROPERTY_TRICKS )
   public int indexOfTricks ( Trick value, int index )
   {
      return ((this.tricks == null)
   	       ? -1
   	       : this.tricks.indexOf (value, index));
   }

   @Property( name = PROPERTY_TRICKS )
   public int lastIndexOfTricks ( Trick value )
   {
      return ((this.tricks == null)
               ? -1
               : this.tricks.lastIndexOf (value));
   }

   @Property( name = PROPERTY_TRICKS )
   public int lastIndexOfTricks ( Trick value, int index )
   {
      return ((this.tricks == null)
               ? -1
               : this.tricks.lastIndexOf (value, index));
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean isBeforeOfTricks ( Trick leftObject, Trick rightObject)
   {
      if (tricks == null)
      {
         return false;
      }
      else
      {
         return tricks.isBefore (leftObject, rightObject);
      }
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean isAfterOfTricks ( Trick leftObject, Trick rightObject)
   {
      if (tricks == null)
      {
         return false;
      }
      else
      {
         return tricks.isAfter (leftObject, rightObject);
      }
   }

   @Property( name = PROPERTY_TRICKS )
   public Trick getNextOfTricks ( Trick object )
   {
      if (tricks == null)
      {
         return null;
      }
      else
      {
         return (Trick) tricks.getNextOf (object);
      }
   }

   @Property( name = PROPERTY_TRICKS )
   public Trick getNextOfTricks ( Trick object, int index)
   {
      if (tricks == null)
      {
         return null;
      }
      else
      {
         return (Trick) tricks.getNextOf (object, index);
      }
   }

   @Property( name = PROPERTY_TRICKS )
   public Trick getPreviousOfTricks ( Trick object)
   {
      if (tricks == null)
      {
         return null;
      }
      else
      {
         return (Trick) tricks.getPreviousOf (object);
      }
   }

   @Property( name = PROPERTY_TRICKS )
   public Trick getPreviousOfTricks ( Trick object, int index )
   {
      if (tricks == null)
      {
         return null;
      }
      else
      {
         return (Trick) tricks.getPreviousOf (object, index);
      }
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean addAfterOfTricks ( Trick refObject, Trick value)
   {
      boolean changed = false;
      if (tricks != null)
      {
         int index = tricks.indexOf (refObject);
         changed = addToTricks (index+1, value);
      }
      return changed;
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean addBeforeOfTricks ( Trick refObject, Trick value)
   {
      boolean changed = false;
      if (tricks != null)
      {
         int index = tricks.indexOf (refObject);
         changed = addToTricks (index, value);
      }
      return changed;
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean addToTricks (int index, Trick value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.tricks == null)
         {
            this.tricks = new FLinkedList<Trick> (); // or FTreeSet () or FLinkedList ()
         }
         int oldIndex = this.indexOfTricks (value);
         if (oldIndex != index)
         {
            try
            {
            
               if (oldIndex > -1)
               {
                  tricks.remove (oldIndex);
               }
               tricks.add (index, value);
               if (oldIndex < 0)
               {
                  value.addToCards (this);
               }
               changed = true;
            
            }
            catch (IndexOutOfBoundsException ex)
            {
               return false;
            }
         }
      }
      return changed;
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean setInTricks (int index, Trick value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.tricks == null)
         {
            this.tricks = new FLinkedList<Trick> (); // or FTreeSet () or FLinkedList ()
         }
         int oldIndex = this.indexOfTricks (value);
         if (oldIndex != index)
         {
            try
            {
            
               Trick oldValue = (Trick)this.tricks.set (index, value);
               if (oldIndex > -1)
               {
                  this.tricks.remove (oldIndex);
               }
               if (oldValue != value)
               {
                  if (oldValue != null)
                  {
                     oldValue.removeFromCards (this);
                  }
                  if (oldIndex < 0)
                  {
                     value.addToCards (this);
                  }
                  changed = true;
               }
            
            }
            catch (IndexOutOfBoundsException ex)
            {
               return false;
            }
         }
      }
      return changed;
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean removeFromTricks (int index)
   {
      boolean changed = false;

      if (this.tricks != null && (index >= 0 && index < this.tricks.size ()))
      {
      
         Trick tmpValue = (Trick) this.tricks.remove (index);
         if (tmpValue != null)
         {
            tmpValue.removeFromCards (this);
            changed = true;
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TRICKS )
   public boolean removeFromTricks (int index, Trick value)
   {
      boolean changed = false;

      if ((this.tricks != null) && (value != null) && 
          (index >= 0 && index < this.tricks.size ()))
      {
         Trick oldValue = (Trick) this.tricks.get (index);
         if (oldValue == value)
         {
         
            changed = this.removeFromTricks (index);
         
         }
      }
      return changed;
   }

   @Property( name = PROPERTY_TRICKS )
   public ListIterator<? extends Trick> iteratorOfTricks ( Trick  lowerBound )
   {
      ListIterator<Trick> result = FEmptyListIterator.<Trick>get ();

      if (tricks != null && lowerBound != null)
      {
         int index = tricks.indexOf (lowerBound) + 1;
         result = tricks.listIterator (index);
      }
      else if (tricks != null && lowerBound == null)
      {
         result = tricks.listIterator (0);
      }

      return result;
   }

   @Property( name = PROPERTY_TRICKS )
   public ListIterator<? extends Trick> iteratorOfTricks (int index)
   {
      return ((this.tricks == null)
              ? FEmptyListIterator.<Trick>get ()
              : this.tricks.listIterator (Math.max(0,Math.min(index,this.tricks.size ()))));
   }

   /**
    * <pre>
    *           0..1     trump     0..1
    * Card ------------------------- Turn
    *           trump               turn
    * </pre>
    */
   public static final String PROPERTY_TURN = "turn";

   @Property( name = PROPERTY_TURN, partner = Turn.PROPERTY_TRUMP, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Turn turn;

   @Property( name = PROPERTY_TURN )
   public boolean setTurn (Turn value)
   {
      boolean changed = false;

      if (this.turn != value)
      {
      
         Turn oldValue = this.turn;
         Card source = this;
         if (this.turn != null)
         {
            this.turn = null;
            oldValue.setTrump (null);
         }
         this.turn = value;

         if (value != null)
         {
            value.setTrump (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TURN )
   public Card withTurn (Turn value)
   {
      setTurn (value);
      return this;
   }

   public Turn getTurn ()
   {
      return this.turn;
   }

   public static final String PROPERTY_VALUE = "value";

   @Property( name = PROPERTY_VALUE, kind = ReferenceHandler.ReferenceKind.ATTRIBUTE )
   private int value;

   @Property( name = PROPERTY_VALUE )
   public void setValue (int value)
   {
      this.value = value;
   }

   public Card withValue (int value)
   {
      setValue (value);
      return this;
   }

   @Property( name = PROPERTY_VALUE )
   public int getValue ()
   {
      return this.value;
   }

   public void removeYou()
   {
      this.setPlayer (null);
      this.setStack (null);
      this.removeAllFromTricks ();
      this.setTurn (null);
   }
}


