/*
 * generated by Fujaba - CodeGen2
 */
package de.uks.pmss11.wizard;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath
import de.upb.tools.sdm.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class Stack
{



   /**
    * <pre>
    *           0..1     cards     0..n
    * Stack ------------------------- Card
    *           stack               cards
    * </pre>
    */
   public static final String PROPERTY_CARDS = "cards";

   @Property( name = PROPERTY_CARDS, partner = Card.PROPERTY_STACK, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FLinkedList<Card> cards;

   @Property( name = PROPERTY_CARDS )
   public List<? extends Card> getCards()
   {
      return ((this.cards == null)
              ? Collections.EMPTY_LIST
              : Collections.unmodifiableList(this.cards));
   }

   @Property( name = PROPERTY_CARDS )
   public boolean addToCards (Card value)
   {
      boolean changed = false;

      if (value != null && !this.hasInCards (value))
      {
         if (this.cards == null)
         {
            this.cards = new FLinkedList<Card> ();

         }
      
         changed = this.cards.add (value);
         if (changed)
         {
            value.setStack (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public Stack withCards (Card value)
   {
      addToCards (value);
      return this;
   }

   public Stack withoutCards (Card value)
   {
      removeFromCards (value);
      return this;
   }


   public boolean removeFromCards (Card value)
   {
      boolean changed = false;

      if ((this.cards != null) && (value != null))
      {
      
         changed = this.cards.remove (value);
         if (changed)
         {
            value.setStack (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public void removeAllFromCards (){
   
      Card tmpValue;
      Iterator<? extends Card> iter = this.iteratorOfCards ();
      while (iter.hasNext ())
      {
         tmpValue = (Card) iter.next ();
         this.removeFromCards (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_CARDS )
   public boolean hasInCards (Card value)
   {
      return ((this.cards != null) &&
              (value != null) &&
              this.cards.contains (value));
   }

   @Property( name = PROPERTY_CARDS )
   public ListIterator<? extends Card> iteratorOfCards ()
   {
      return ((this.cards == null)
              ? FEmptyListIterator.<Card>get ()
              : this.cards.listIterator());
   }

   @Property( name = PROPERTY_CARDS )
   public int sizeOfCards ()
   {
      return ((this.cards == null)
              ? 0
              : this.cards.size ());
   }
   @Property( name = PROPERTY_CARDS )
   public Card getFirstOfCards ()
   {
      if (cards == null)
      {
         return null;
      }
      else
      {
         if (cards.size() == 0) 	 
         { 	 
            return null; 	 
         }
         return (Card) cards.getFirst ();
      }
   }

   @Property( name = PROPERTY_CARDS )
   public Card getLastOfCards ()
   {
      if (cards == null)
      {
         return null;
      }
      else
      {
         if (cards.size() == 0) 	 
         { 	 
            return null; 	 
         }
         return (Card) cards.getLast ();
      }
   }
   @Property( name = PROPERTY_CARDS )
   public Card getFromCards ( int index )
   {
      if (index >= 0 && index < sizeOfCards ())
      {
         return (Card) this.cards.get (index);
      }
      else
      {
         throw new IllegalArgumentException ("getCardsAt(" + index + ")" );
      }
   }

   @Property( name = PROPERTY_CARDS )
   public int indexOfCards ( Card value )
   {
      return ((this.cards == null)
              ? -1
              : this.cards.indexOf (value));
   }

   @Property( name = PROPERTY_CARDS )
   public int indexOfCards ( Card value, int index )
   {
      return ((this.cards == null)
   	       ? -1
   	       : this.cards.indexOf (value, index));
   }

   @Property( name = PROPERTY_CARDS )
   public int lastIndexOfCards ( Card value )
   {
      return ((this.cards == null)
               ? -1
               : this.cards.lastIndexOf (value));
   }

   @Property( name = PROPERTY_CARDS )
   public int lastIndexOfCards ( Card value, int index )
   {
      return ((this.cards == null)
               ? -1
               : this.cards.lastIndexOf (value, index));
   }

   @Property( name = PROPERTY_CARDS )
   public boolean isBeforeOfCards ( Card leftObject, Card rightObject)
   {
      if (cards == null)
      {
         return false;
      }
      else
      {
         return cards.isBefore (leftObject, rightObject);
      }
   }

   @Property( name = PROPERTY_CARDS )
   public boolean isAfterOfCards ( Card leftObject, Card rightObject)
   {
      if (cards == null)
      {
         return false;
      }
      else
      {
         return cards.isAfter (leftObject, rightObject);
      }
   }

   @Property( name = PROPERTY_CARDS )
   public Card getNextOfCards ( Card object )
   {
      if (cards == null)
      {
         return null;
      }
      else
      {
         return (Card) cards.getNextOf (object);
      }
   }

   @Property( name = PROPERTY_CARDS )
   public Card getNextOfCards ( Card object, int index)
   {
      if (cards == null)
      {
         return null;
      }
      else
      {
         return (Card) cards.getNextOf (object, index);
      }
   }

   @Property( name = PROPERTY_CARDS )
   public Card getPreviousOfCards ( Card object)
   {
      if (cards == null)
      {
         return null;
      }
      else
      {
         return (Card) cards.getPreviousOf (object);
      }
   }

   @Property( name = PROPERTY_CARDS )
   public Card getPreviousOfCards ( Card object, int index )
   {
      if (cards == null)
      {
         return null;
      }
      else
      {
         return (Card) cards.getPreviousOf (object, index);
      }
   }

   @Property( name = PROPERTY_CARDS )
   public boolean addAfterOfCards ( Card refObject, Card value)
   {
      boolean changed = false;
      if (cards != null)
      {
         int index = cards.indexOf (refObject);
         changed = addToCards (index+1, value);
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public boolean addBeforeOfCards ( Card refObject, Card value)
   {
      boolean changed = false;
      if (cards != null)
      {
         int index = cards.indexOf (refObject);
         changed = addToCards (index, value);
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public boolean addToCards (int index, Card value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.cards == null)
         {
            this.cards = new FLinkedList<Card> (); // or FTreeSet () or FLinkedList ()
         }
         int oldIndex = this.indexOfCards (value);
         if (oldIndex != index)
         {
            try
            {
            
               if (oldIndex > -1)
               {
                  cards.remove (oldIndex);
               }
               cards.add (index, value);
               if (oldIndex < 0)
               {
                  value.setStack (this);
               }
               changed = true;
            
            }
            catch (IndexOutOfBoundsException ex)
            {
               return false;
            }
         }
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public boolean setInCards (int index, Card value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.cards == null)
         {
            this.cards = new FLinkedList<Card> (); // or FTreeSet () or FLinkedList ()
         }
         int oldIndex = this.indexOfCards (value);
         if (oldIndex != index)
         {
            try
            {
            
               Card oldValue = (Card)this.cards.set (index, value);
               if (oldIndex > -1)
               {
                  this.cards.remove (oldIndex);
               }
               if (oldValue != value)
               {
                  if (oldValue != null)
                  {
                     oldValue.setStack (null);
                  }
                  if (oldIndex < 0)
                  {
                     value.setStack (this);
                  }
                  changed = true;
               }
            
            }
            catch (IndexOutOfBoundsException ex)
            {
               return false;
            }
         }
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public boolean removeFromCards (int index)
   {
      boolean changed = false;

      if (this.cards != null && (index >= 0 && index < this.cards.size ()))
      {
      
         Card tmpValue = (Card) this.cards.remove (index);
         if (tmpValue != null)
         {
            tmpValue.setStack (null);
            changed = true;
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public boolean removeFromCards (int index, Card value)
   {
      boolean changed = false;

      if ((this.cards != null) && (value != null) && 
          (index >= 0 && index < this.cards.size ()))
      {
         Card oldValue = (Card) this.cards.get (index);
         if (oldValue == value)
         {
         
            changed = this.removeFromCards (index);
         
         }
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public ListIterator<? extends Card> iteratorOfCards ( Card  lowerBound )
   {
      ListIterator<Card> result = FEmptyListIterator.<Card>get ();

      if (cards != null && lowerBound != null)
      {
         int index = cards.indexOf (lowerBound) + 1;
         result = cards.listIterator (index);
      }
      else if (cards != null && lowerBound == null)
      {
         result = cards.listIterator (0);
      }

      return result;
   }

   @Property( name = PROPERTY_CARDS )
   public ListIterator<? extends Card> iteratorOfCards (int index)
   {
      return ((this.cards == null)
              ? FEmptyListIterator.<Card>get ()
              : this.cards.listIterator (Math.max(0,Math.min(index,this.cards.size ()))));
   }

   public Card popCard ()
   {
      boolean fujaba__Success = false;
      Iterator fujaba__IterThisToSomeCard = null;
      Card someCard = null;

      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link cards from this to someCard
         fujaba__Success = false;
         fujaba__IterThisToSomeCard = this.iteratorOfCards ();

         while ( !(fujaba__Success) && fujaba__IterThisToSomeCard.hasNext () )
         {
            try
            {
               someCard = (Card) fujaba__IterThisToSomeCard.next ();

               // check object someCard is really bound
               JavaSDM.ensure ( someCard != null );

               fujaba__Success = true;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         JavaSDM.ensure (fujaba__Success);
         // destroy link cards from someCard to this
         someCard.setStack (null);
         fujaba__Success = true;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      if ( !( fujaba__Success ) )
      {
         return null;

      }
      return someCard;
   }

   /**
    * <pre>
    *           0..1     closedStack     0..1
    * Stack ------------------------- WizardGame
    *           closedStack               wizardCStackRev
    * </pre>
    */
   public static final String PROPERTY_WIZARDC_STACK_REV = "wizardCStackRev";

   @Property( name = PROPERTY_WIZARDC_STACK_REV, partner = WizardGame.PROPERTY_CLOSED_STACK, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private WizardGame wizardCStackRev;

   @Property( name = PROPERTY_WIZARDC_STACK_REV )
   public boolean setWizardCStackRev (WizardGame value)
   {
      boolean changed = false;

      if (this.wizardCStackRev != value)
      {
      
         WizardGame oldValue = this.wizardCStackRev;
         Stack source = this;
         if (this.wizardCStackRev != null)
         {
            this.wizardCStackRev = null;
            oldValue.setClosedStack (null);
         }
         this.wizardCStackRev = value;

         if (value != null)
         {
            value.setClosedStack (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_WIZARDC_STACK_REV )
   public Stack withWizardCStackRev (WizardGame value)
   {
      setWizardCStackRev (value);
      return this;
   }

   public WizardGame getWizardCStackRev ()
   {
      return this.wizardCStackRev;
   }

   /**
    * <pre>
    *           0..1     openStack     0..1
    * Stack ------------------------- WizardGame
    *           openStack               wizardOStackRev
    * </pre>
    */
   public static final String PROPERTY_WIZARDO_STACK_REV = "wizardOStackRev";

   @Property( name = PROPERTY_WIZARDO_STACK_REV, partner = WizardGame.PROPERTY_OPEN_STACK, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private WizardGame wizardOStackRev;

   @Property( name = PROPERTY_WIZARDO_STACK_REV )
   public boolean setWizardOStackRev (WizardGame value)
   {
      boolean changed = false;

      if (this.wizardOStackRev != value)
      {
      
         WizardGame oldValue = this.wizardOStackRev;
         Stack source = this;
         if (this.wizardOStackRev != null)
         {
            this.wizardOStackRev = null;
            oldValue.setOpenStack (null);
         }
         this.wizardOStackRev = value;

         if (value != null)
         {
            value.setOpenStack (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_WIZARDO_STACK_REV )
   public Stack withWizardOStackRev (WizardGame value)
   {
      setWizardOStackRev (value);
      return this;
   }

   public WizardGame getWizardOStackRev ()
   {
      return this.wizardOStackRev;
   }

   public void removeYou()
   {
      this.removeAllFromCards ();
      this.setWizardCStackRev (null);
      this.setWizardOStackRev (null);
   }
}


