/*
 * generated by Fujaba - CodeGen2
 */
package de.uks.pmss11.wizard;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class Trick
{



   /**
    * <pre>
    *           0..n     cards     0..n
    * Trick ------------------------- Card
    *           tricks               cards
    * </pre>
    */
   public static final String PROPERTY_CARDS = "cards";

   @Property( name = PROPERTY_CARDS, partner = Card.PROPERTY_TRICKS, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FLinkedList<Card> cards;

   @Property( name = PROPERTY_CARDS )
   public List<? extends Card> getCards()
   {
      return ((this.cards == null)
              ? Collections.EMPTY_LIST
              : Collections.unmodifiableList(this.cards));
   }

   @Property( name = PROPERTY_CARDS )
   public boolean addToCards (Card value)
   {
      boolean changed = false;

      if (value != null && !this.hasInCards (value))
      {
         if (this.cards == null)
         {
            this.cards = new FLinkedList<Card> ();

         }
      
         changed = this.cards.add (value);
         if (changed)
         {
            value.addToTricks (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public Trick withCards (Card value)
   {
      addToCards (value);
      return this;
   }

   public Trick withoutCards (Card value)
   {
      removeFromCards (value);
      return this;
   }


   public boolean removeFromCards (Card value)
   {
      boolean changed = false;

      if ((this.cards != null) && (value != null))
      {
      
         changed = this.cards.remove (value);
         if (changed)
         {
            value.removeFromTricks (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public void removeAllFromCards (){
   
      Card tmpValue;
      Iterator<? extends Card> iter = this.iteratorOfCards ();
      while (iter.hasNext ())
      {
         tmpValue = (Card) iter.next ();
         this.removeFromCards (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_CARDS )
   public boolean hasInCards (Card value)
   {
      return ((this.cards != null) &&
              (value != null) &&
              this.cards.contains (value));
   }

   @Property( name = PROPERTY_CARDS )
   public ListIterator<? extends Card> iteratorOfCards ()
   {
      return ((this.cards == null)
              ? FEmptyListIterator.<Card>get ()
              : this.cards.listIterator());
   }

   @Property( name = PROPERTY_CARDS )
   public int sizeOfCards ()
   {
      return ((this.cards == null)
              ? 0
              : this.cards.size ());
   }
   @Property( name = PROPERTY_CARDS )
   public Card getFirstOfCards ()
   {
      if (cards == null)
      {
         return null;
      }
      else
      {
         if (cards.size() == 0) 	 
         { 	 
            return null; 	 
         }
         return (Card) cards.getFirst ();
      }
   }

   @Property( name = PROPERTY_CARDS )
   public Card getLastOfCards ()
   {
      if (cards == null)
      {
         return null;
      }
      else
      {
         if (cards.size() == 0) 	 
         { 	 
            return null; 	 
         }
         return (Card) cards.getLast ();
      }
   }
   @Property( name = PROPERTY_CARDS )
   public Card getFromCards ( int index )
   {
      if (index >= 0 && index < sizeOfCards ())
      {
         return (Card) this.cards.get (index);
      }
      else
      {
         throw new IllegalArgumentException ("getCardsAt(" + index + ")" );
      }
   }

   @Property( name = PROPERTY_CARDS )
   public int indexOfCards ( Card value )
   {
      return ((this.cards == null)
              ? -1
              : this.cards.indexOf (value));
   }

   @Property( name = PROPERTY_CARDS )
   public int indexOfCards ( Card value, int index )
   {
      return ((this.cards == null)
   	       ? -1
   	       : this.cards.indexOf (value, index));
   }

   @Property( name = PROPERTY_CARDS )
   public int lastIndexOfCards ( Card value )
   {
      return ((this.cards == null)
               ? -1
               : this.cards.lastIndexOf (value));
   }

   @Property( name = PROPERTY_CARDS )
   public int lastIndexOfCards ( Card value, int index )
   {
      return ((this.cards == null)
               ? -1
               : this.cards.lastIndexOf (value, index));
   }

   @Property( name = PROPERTY_CARDS )
   public boolean isBeforeOfCards ( Card leftObject, Card rightObject)
   {
      if (cards == null)
      {
         return false;
      }
      else
      {
         return cards.isBefore (leftObject, rightObject);
      }
   }

   @Property( name = PROPERTY_CARDS )
   public boolean isAfterOfCards ( Card leftObject, Card rightObject)
   {
      if (cards == null)
      {
         return false;
      }
      else
      {
         return cards.isAfter (leftObject, rightObject);
      }
   }

   @Property( name = PROPERTY_CARDS )
   public Card getNextOfCards ( Card object )
   {
      if (cards == null)
      {
         return null;
      }
      else
      {
         return (Card) cards.getNextOf (object);
      }
   }

   @Property( name = PROPERTY_CARDS )
   public Card getNextOfCards ( Card object, int index)
   {
      if (cards == null)
      {
         return null;
      }
      else
      {
         return (Card) cards.getNextOf (object, index);
      }
   }

   @Property( name = PROPERTY_CARDS )
   public Card getPreviousOfCards ( Card object)
   {
      if (cards == null)
      {
         return null;
      }
      else
      {
         return (Card) cards.getPreviousOf (object);
      }
   }

   @Property( name = PROPERTY_CARDS )
   public Card getPreviousOfCards ( Card object, int index )
   {
      if (cards == null)
      {
         return null;
      }
      else
      {
         return (Card) cards.getPreviousOf (object, index);
      }
   }

   @Property( name = PROPERTY_CARDS )
   public boolean addAfterOfCards ( Card refObject, Card value)
   {
      boolean changed = false;
      if (cards != null)
      {
         int index = cards.indexOf (refObject);
         changed = addToCards (index+1, value);
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public boolean addBeforeOfCards ( Card refObject, Card value)
   {
      boolean changed = false;
      if (cards != null)
      {
         int index = cards.indexOf (refObject);
         changed = addToCards (index, value);
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public boolean addToCards (int index, Card value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.cards == null)
         {
            this.cards = new FLinkedList<Card> (); // or FTreeSet () or FLinkedList ()
         }
         int oldIndex = this.indexOfCards (value);
         if (oldIndex != index)
         {
            try
            {
            
               if (oldIndex > -1)
               {
                  cards.remove (oldIndex);
               }
               cards.add (index, value);
               if (oldIndex < 0)
               {
                  value.addToTricks (this);
               }
               changed = true;
            
            }
            catch (IndexOutOfBoundsException ex)
            {
               return false;
            }
         }
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public boolean setInCards (int index, Card value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.cards == null)
         {
            this.cards = new FLinkedList<Card> (); // or FTreeSet () or FLinkedList ()
         }
         int oldIndex = this.indexOfCards (value);
         if (oldIndex != index)
         {
            try
            {
            
               Card oldValue = (Card)this.cards.set (index, value);
               if (oldIndex > -1)
               {
                  this.cards.remove (oldIndex);
               }
               if (oldValue != value)
               {
                  if (oldValue != null)
                  {
                     oldValue.removeFromTricks (this);
                  }
                  if (oldIndex < 0)
                  {
                     value.addToTricks (this);
                  }
                  changed = true;
               }
            
            }
            catch (IndexOutOfBoundsException ex)
            {
               return false;
            }
         }
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public boolean removeFromCards (int index)
   {
      boolean changed = false;

      if (this.cards != null && (index >= 0 && index < this.cards.size ()))
      {
      
         Card tmpValue = (Card) this.cards.remove (index);
         if (tmpValue != null)
         {
            tmpValue.removeFromTricks (this);
            changed = true;
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public boolean removeFromCards (int index, Card value)
   {
      boolean changed = false;

      if ((this.cards != null) && (value != null) && 
          (index >= 0 && index < this.cards.size ()))
      {
         Card oldValue = (Card) this.cards.get (index);
         if (oldValue == value)
         {
         
            changed = this.removeFromCards (index);
         
         }
      }
      return changed;
   }

   @Property( name = PROPERTY_CARDS )
   public ListIterator<? extends Card> iteratorOfCards ( Card  lowerBound )
   {
      ListIterator<Card> result = FEmptyListIterator.<Card>get ();

      if (cards != null && lowerBound != null)
      {
         int index = cards.indexOf (lowerBound) + 1;
         result = cards.listIterator (index);
      }
      else if (cards != null && lowerBound == null)
      {
         result = cards.listIterator (0);
      }

      return result;
   }

   @Property( name = PROPERTY_CARDS )
   public ListIterator<? extends Card> iteratorOfCards (int index)
   {
      return ((this.cards == null)
              ? FEmptyListIterator.<Card>get ()
              : this.cards.listIterator (Math.max(0,Math.min(index,this.cards.size ()))));
   }

   /**
    * <pre>
    *           0..1     highestCard     0..1
    * Trick ------------------------> Card
    *           trick               highestCard
    * </pre>
    */
   public static final String PROPERTY_HIGHEST_CARD = "highestCard";

   @Property( name = PROPERTY_HIGHEST_CARD, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Card highestCard;

   @Property( name = PROPERTY_HIGHEST_CARD )
   public boolean setHighestCard (Card value)
   {
      boolean changed = false;

      if (this.highestCard != value)
      {
      
         Card oldValue = this.highestCard;
         this.highestCard = value;
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_HIGHEST_CARD )
   public Trick withHighestCard (Card value)
   {
      setHighestCard (value);
      return this;
   }

   public Card getHighestCard ()
   {
      return this.highestCard;
   }

   /**
    * <pre>
    *           0..n     tricks     0..1
    * Trick ------------------------- Player
    *           tricks               player
    * </pre>
    */
   public static final String PROPERTY_PLAYER = "player";

   @Property( name = PROPERTY_PLAYER, partner = Player.PROPERTY_TRICKS, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Player player;

   @Property( name = PROPERTY_PLAYER )
   public boolean setPlayer (Player value)
   {
      boolean changed = false;

      if (this.player != value)
      {
      
         Player oldValue = this.player;
         Trick source = this;
         if (this.player != null)
         {
            this.player = null;
            oldValue.removeFromTricks (this);
         }
         this.player = value;

         if (value != null)
         {
            value.addToTricks (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_PLAYER )
   public Trick withPlayer (Player value)
   {
      setPlayer (value);
      return this;
   }

   public Player getPlayer ()
   {
      return this.player;
   }

   /**
    * <pre>
    *           0..n     turn     0..1
    * Trick ------------------------- Turn
    *           tricks               turn
    * </pre>
    */
   public static final String PROPERTY_TURN = "turn";

   @Property( name = PROPERTY_TURN, partner = Turn.PROPERTY_TRICKS, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Turn turn;

   @Property( name = PROPERTY_TURN )
   public boolean setTurn (Turn value)
   {
      boolean changed = false;

      if (this.turn != value)
      {
      
         Turn oldValue = this.turn;
         Trick source = this;
         if (this.turn != null)
         {
            this.turn = null;
            oldValue.removeFromTricks (this);
         }
         this.turn = value;

         if (value != null)
         {
            value.addToTricks (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TURN )
   public Trick withTurn (Turn value)
   {
      setTurn (value);
      return this;
   }

   public Turn getTurn ()
   {
      return this.turn;
   }

   public void removeYou()
   {
      this.removeAllFromCards ();
      this.setHighestCard (null);
      this.setPlayer (null);
      this.setTurn (null);
   }
}


