/*
 * generated by Fujaba - CodeGen2
 */
package de.uks.pmss11.wizard;
import de.uni_kassel.features.annotation.util.Property; // requires Fujaba5/libs/features.jar in classpath
import de.uni_kassel.features.ReferenceHandler; // requires Fujaba5/libs/features.jar in classpath
import de.upb.tools.sdm.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath
import java.util.*;
import de.upb.tools.fca.*; // requires Fujaba5/libs/RuntimeTools.jar in classpath


public class WizardGame
{



   /**
    * <pre>
    *           0..1     closedStack     0..1
    * WizardGame ------------------------- Stack
    *           wizardCStackRev               closedStack
    * </pre>
    */
   public static final String PROPERTY_CLOSED_STACK = "closedStack";

   @Property( name = PROPERTY_CLOSED_STACK, partner = Stack.PROPERTY_WIZARDC_STACK_REV, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Stack closedStack;

   @Property( name = PROPERTY_CLOSED_STACK )
   public boolean setClosedStack (Stack value)
   {
      boolean changed = false;

      if (this.closedStack != value)
      {
      
         Stack oldValue = this.closedStack;
         WizardGame source = this;
         if (this.closedStack != null)
         {
            this.closedStack = null;
            oldValue.setWizardCStackRev (null);
         }
         this.closedStack = value;

         if (value != null)
         {
            value.setWizardCStackRev (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CLOSED_STACK )
   public WizardGame withClosedStack (Stack value)
   {
      setClosedStack (value);
      return this;
   }

   public Stack getClosedStack ()
   {
      return this.closedStack;
   }

   /**
    * <pre>
    *           0..1     currentPlayer     0..1
    * WizardGame ------------------------- Player
    *           currentPlayerRev               currentPlayer
    * </pre>
    */
   public static final String PROPERTY_CURRENT_PLAYER = "currentPlayer";

   @Property( name = PROPERTY_CURRENT_PLAYER, partner = Player.PROPERTY_CURRENT_PLAYER_REV, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Player currentPlayer;

   @Property( name = PROPERTY_CURRENT_PLAYER )
   public boolean setCurrentPlayer (Player value)
   {
      boolean changed = false;

      if (this.currentPlayer != value)
      {
      
         Player oldValue = this.currentPlayer;
         WizardGame source = this;
         if (this.currentPlayer != null)
         {
            this.currentPlayer = null;
            oldValue.setCurrentPlayerRev (null);
         }
         this.currentPlayer = value;

         if (value != null)
         {
            value.setCurrentPlayerRev (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CURRENT_PLAYER )
   public WizardGame withCurrentPlayer (Player value)
   {
      setCurrentPlayer (value);
      return this;
   }

   public Player getCurrentPlayer ()
   {
      return this.currentPlayer;
   }

   /**
    * <pre>
    *           0..1     currentTurn     0..1
    * WizardGame ------------------------> Turn
    *           currentTurnRev               currentTurn
    * </pre>
    */
   public static final String PROPERTY_CURRENT_TURN = "currentTurn";

   @Property( name = PROPERTY_CURRENT_TURN, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Turn currentTurn;

   @Property( name = PROPERTY_CURRENT_TURN )
   public boolean setCurrentTurn (Turn value)
   {
      boolean changed = false;

      if (this.currentTurn != value)
      {
      
         Turn oldValue = this.currentTurn;
         this.currentTurn = value;
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_CURRENT_TURN )
   public WizardGame withCurrentTurn (Turn value)
   {
      setCurrentTurn (value);
      return this;
   }

   public Turn getCurrentTurn ()
   {
      return this.currentTurn;
   }

   public void evaluateWinner ()
   {
   }

   public void init (String[] playerNames )
   {
      boolean fujaba__Success = false;
      int i = 0;
      Player p = null;
      Stack openStack = null;
      Stack closedStack = null;
      String color = null;
      Card newCard = null;
      Mage mage = null;
      Fool fool = null;
      Iterator fujaba__IterThisToPlayer = null;
      Player player = null;

      // story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // collabStat call
         i = 0;
         fujaba__Success = true;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      do
      {
         // // Create players
         // story pattern storypatternwiththis
         try 
         {
            fujaba__Success = false; 

            // constraint i < playerNames.length
            JavaSDM.ensure ( i < playerNames.length );
            // create object p
            p = new Player ( );

            // assign attribute p
            p.setName (playerNames[i]);
            // create link players from p to this
            p.setWizardGame (this);

            // collabStat call
            i++;
            fujaba__Success = true;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false;
         }


      }
      while ( fujaba__Success );// story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // create object openStack
         openStack = new Stack ( );

         // create object closedStack
         closedStack = new Stack ( );

         // create link openStack from openStack to this
         openStack.setWizardOStackRev (this);

         // create link closedStack from closedStack to this
         closedStack.setWizardCStackRev (this);

         // collabStat call
         color = "Red";
         // collabStat call
         i = 0;
         fujaba__Success = true;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      while ( !( i > 51 ) )
      {
         // // Switch the color
         // story pattern successor
         try 
         {
            fujaba__Success = false; 

            // check object closedStack is really bound
            JavaSDM.ensure ( closedStack != null );
            // create object newCard
            newCard = new Card ( );

            // assign attribute newCard
            newCard.setValue ((i % 13) + 1);
            // assign attribute newCard
            newCard.setColor (color);
            // create link cards from newCard to closedStack
            newCard.setStack (closedStack);

            // collabStat call
            if ( i == 12 )
            {
            color = "Green";
            }
            // collabStat call
            if ( i == 25 )
            {
            color = "Blue";
            }
            // collabStat call
            if ( i == 38 )
            {
            color = "Yellow";
            }
            // collabStat call
            i++;
            fujaba__Success = true;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false;
         }


      }
      do
      {
         // // Create mages and fools
         // story pattern successor
         try 
         {
            fujaba__Success = false; 

            // check object closedStack is really bound
            JavaSDM.ensure ( closedStack != null );
            // create object mage
            mage = new Mage ( );

            // create object fool
            fool = new Fool ( );

            // assign attribute mage
            mage.setColor ("White");
            // assign attribute mage
            mage.setValue (14);
            // assign attribute fool
            fool.setColor ("White");
            // create link cards from mage to closedStack
            mage.setStack (closedStack);

            // create link cards from fool to closedStack
            fool.setStack (closedStack);

            // collabStat call
            i = i+2;
            fujaba__Success = true;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false;
         }


      }
      while ( i < 60 );// story pattern storypatternwiththis
      try 
      {
         fujaba__Success = false; 

         // iterate to-many link players from this to player
         fujaba__Success = false;
         fujaba__IterThisToPlayer = this.iteratorOfPlayers ();

         while ( fujaba__IterThisToPlayer.hasNext () )
         {
            try
            {
               player = (Player) fujaba__IterThisToPlayer.next ();

               // check object player is really bound
               JavaSDM.ensure ( player != null );
               // collabStat call
               player.doForecast();

               fujaba__Success = true;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false;
            }
         }
         JavaSDM.ensure (fujaba__Success);
         fujaba__Success = true;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false;
      }

      return ;
   }

   /**
    * <pre>
    *           0..1     openStack     0..1
    * WizardGame ------------------------- Stack
    *           wizardOStackRev               openStack
    * </pre>
    */
   public static final String PROPERTY_OPEN_STACK = "openStack";

   @Property( name = PROPERTY_OPEN_STACK, partner = Stack.PROPERTY_WIZARDO_STACK_REV, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Stack openStack;

   @Property( name = PROPERTY_OPEN_STACK )
   public boolean setOpenStack (Stack value)
   {
      boolean changed = false;

      if (this.openStack != value)
      {
      
         Stack oldValue = this.openStack;
         WizardGame source = this;
         if (this.openStack != null)
         {
            this.openStack = null;
            oldValue.setWizardOStackRev (null);
         }
         this.openStack = value;

         if (value != null)
         {
            value.setWizardOStackRev (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_OPEN_STACK )
   public WizardGame withOpenStack (Stack value)
   {
      setOpenStack (value);
      return this;
   }

   public Stack getOpenStack ()
   {
      return this.openStack;
   }

   /**
    * <pre>
    *           0..1     players     0..n
    * WizardGame ------------------------- Player
    *           wizardGame               players
    * </pre>
    */
   public static final String PROPERTY_PLAYERS = "players";

   @Property( name = PROPERTY_PLAYERS, partner = Player.PROPERTY_WIZARD_GAME, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FHashSet<Player> players;

   @Property( name = PROPERTY_PLAYERS )
   public Set<? extends Player> getPlayers()
   {
      return ((this.players == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.players));
   }

   @Property( name = PROPERTY_PLAYERS )
   public boolean addToPlayers (Player value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.players == null)
         {
            this.players = new FHashSet<Player> ();

         }
      
         changed = this.players.add (value);
         if (changed)
         {
            value.setWizardGame (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_PLAYERS )
   public WizardGame withPlayers (Player value)
   {
      addToPlayers (value);
      return this;
   }

   public WizardGame withoutPlayers (Player value)
   {
      removeFromPlayers (value);
      return this;
   }


   public boolean removeFromPlayers (Player value)
   {
      boolean changed = false;

      if ((this.players != null) && (value != null))
      {
      
         changed = this.players.remove (value);
         if (changed)
         {
            value.setWizardGame (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_PLAYERS )
   public void removeAllFromPlayers (){
   
      Player tmpValue;
      Iterator<? extends Player> iter = this.iteratorOfPlayers ();
      while (iter.hasNext ())
      {
         tmpValue = (Player) iter.next ();
         this.removeFromPlayers (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_PLAYERS )
   public boolean hasInPlayers (Player value)
   {
      return ((this.players != null) &&
              (value != null) &&
              this.players.contains (value));
   }

   @Property( name = PROPERTY_PLAYERS )
   public Iterator<? extends Player> iteratorOfPlayers ()
   {
      return ((this.players == null)
              ? FEmptyIterator.<Player>get ()
              : this.players.iterator ());
   }

   @Property( name = PROPERTY_PLAYERS )
   public int sizeOfPlayers ()
   {
      return ((this.players == null)
              ? 0
              : this.players.size ());
   }

   public void startTurn (int number )
   {
   }

   /**
    * <pre>
    *           0..1     turns     0..n
    * WizardGame ------------------------- Turn
    *           wizardGame               turns
    * </pre>
    */
   public static final String PROPERTY_TURNS = "turns";

   @Property( name = PROPERTY_TURNS, partner = Turn.PROPERTY_WIZARD_GAME, kind = ReferenceHandler.ReferenceKind.TO_MANY,
         adornment = ReferenceHandler.Adornment.NONE)
   private FLinkedList<Turn> turns;

   @Property( name = PROPERTY_TURNS )
   public List<? extends Turn> getTurns()
   {
      return ((this.turns == null)
              ? Collections.EMPTY_LIST
              : Collections.unmodifiableList(this.turns));
   }

   @Property( name = PROPERTY_TURNS )
   public boolean addToTurns (Turn value)
   {
      boolean changed = false;

      if (value != null && !this.hasInTurns (value))
      {
         if (this.turns == null)
         {
            this.turns = new FLinkedList<Turn> ();

         }
      
         changed = this.turns.add (value);
         if (changed)
         {
            value.setWizardGame (this);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TURNS )
   public WizardGame withTurns (Turn value)
   {
      addToTurns (value);
      return this;
   }

   public WizardGame withoutTurns (Turn value)
   {
      removeFromTurns (value);
      return this;
   }


   public boolean removeFromTurns (Turn value)
   {
      boolean changed = false;

      if ((this.turns != null) && (value != null))
      {
      
         changed = this.turns.remove (value);
         if (changed)
         {
            value.setWizardGame (null);
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TURNS )
   public void removeAllFromTurns (){
   
      Turn tmpValue;
      Iterator<? extends Turn> iter = this.iteratorOfTurns ();
      while (iter.hasNext ())
      {
         tmpValue = (Turn) iter.next ();
         this.removeFromTurns (tmpValue);
      }
   
   }

   @Property( name = PROPERTY_TURNS )
   public boolean hasInTurns (Turn value)
   {
      return ((this.turns != null) &&
              (value != null) &&
              this.turns.contains (value));
   }

   @Property( name = PROPERTY_TURNS )
   public ListIterator<? extends Turn> iteratorOfTurns ()
   {
      return ((this.turns == null)
              ? FEmptyListIterator.<Turn>get ()
              : this.turns.listIterator());
   }

   @Property( name = PROPERTY_TURNS )
   public int sizeOfTurns ()
   {
      return ((this.turns == null)
              ? 0
              : this.turns.size ());
   }
   @Property( name = PROPERTY_TURNS )
   public Turn getFirstOfTurns ()
   {
      if (turns == null)
      {
         return null;
      }
      else
      {
         if (turns.size() == 0) 	 
         { 	 
            return null; 	 
         }
         return (Turn) turns.getFirst ();
      }
   }

   @Property( name = PROPERTY_TURNS )
   public Turn getLastOfTurns ()
   {
      if (turns == null)
      {
         return null;
      }
      else
      {
         if (turns.size() == 0) 	 
         { 	 
            return null; 	 
         }
         return (Turn) turns.getLast ();
      }
   }
   @Property( name = PROPERTY_TURNS )
   public Turn getFromTurns ( int index )
   {
      if (index >= 0 && index < sizeOfTurns ())
      {
         return (Turn) this.turns.get (index);
      }
      else
      {
         throw new IllegalArgumentException ("getTurnsAt(" + index + ")" );
      }
   }

   @Property( name = PROPERTY_TURNS )
   public int indexOfTurns ( Turn value )
   {
      return ((this.turns == null)
              ? -1
              : this.turns.indexOf (value));
   }

   @Property( name = PROPERTY_TURNS )
   public int indexOfTurns ( Turn value, int index )
   {
      return ((this.turns == null)
   	       ? -1
   	       : this.turns.indexOf (value, index));
   }

   @Property( name = PROPERTY_TURNS )
   public int lastIndexOfTurns ( Turn value )
   {
      return ((this.turns == null)
               ? -1
               : this.turns.lastIndexOf (value));
   }

   @Property( name = PROPERTY_TURNS )
   public int lastIndexOfTurns ( Turn value, int index )
   {
      return ((this.turns == null)
               ? -1
               : this.turns.lastIndexOf (value, index));
   }

   @Property( name = PROPERTY_TURNS )
   public boolean isBeforeOfTurns ( Turn leftObject, Turn rightObject)
   {
      if (turns == null)
      {
         return false;
      }
      else
      {
         return turns.isBefore (leftObject, rightObject);
      }
   }

   @Property( name = PROPERTY_TURNS )
   public boolean isAfterOfTurns ( Turn leftObject, Turn rightObject)
   {
      if (turns == null)
      {
         return false;
      }
      else
      {
         return turns.isAfter (leftObject, rightObject);
      }
   }

   @Property( name = PROPERTY_TURNS )
   public Turn getNextOfTurns ( Turn object )
   {
      if (turns == null)
      {
         return null;
      }
      else
      {
         return (Turn) turns.getNextOf (object);
      }
   }

   @Property( name = PROPERTY_TURNS )
   public Turn getNextOfTurns ( Turn object, int index)
   {
      if (turns == null)
      {
         return null;
      }
      else
      {
         return (Turn) turns.getNextOf (object, index);
      }
   }

   @Property( name = PROPERTY_TURNS )
   public Turn getPreviousOfTurns ( Turn object)
   {
      if (turns == null)
      {
         return null;
      }
      else
      {
         return (Turn) turns.getPreviousOf (object);
      }
   }

   @Property( name = PROPERTY_TURNS )
   public Turn getPreviousOfTurns ( Turn object, int index )
   {
      if (turns == null)
      {
         return null;
      }
      else
      {
         return (Turn) turns.getPreviousOf (object, index);
      }
   }

   @Property( name = PROPERTY_TURNS )
   public boolean addAfterOfTurns ( Turn refObject, Turn value)
   {
      boolean changed = false;
      if (turns != null)
      {
         int index = turns.indexOf (refObject);
         changed = addToTurns (index+1, value);
      }
      return changed;
   }

   @Property( name = PROPERTY_TURNS )
   public boolean addBeforeOfTurns ( Turn refObject, Turn value)
   {
      boolean changed = false;
      if (turns != null)
      {
         int index = turns.indexOf (refObject);
         changed = addToTurns (index, value);
      }
      return changed;
   }

   @Property( name = PROPERTY_TURNS )
   public boolean addToTurns (int index, Turn value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.turns == null)
         {
            this.turns = new FLinkedList<Turn> (); // or FTreeSet () or FLinkedList ()
         }
         int oldIndex = this.indexOfTurns (value);
         if (oldIndex != index)
         {
            try
            {
            
               if (oldIndex > -1)
               {
                  turns.remove (oldIndex);
               }
               turns.add (index, value);
               if (oldIndex < 0)
               {
                  value.setWizardGame (this);
               }
               changed = true;
            
            }
            catch (IndexOutOfBoundsException ex)
            {
               return false;
            }
         }
      }
      return changed;
   }

   @Property( name = PROPERTY_TURNS )
   public boolean setInTurns (int index, Turn value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.turns == null)
         {
            this.turns = new FLinkedList<Turn> (); // or FTreeSet () or FLinkedList ()
         }
         int oldIndex = this.indexOfTurns (value);
         if (oldIndex != index)
         {
            try
            {
            
               Turn oldValue = (Turn)this.turns.set (index, value);
               if (oldIndex > -1)
               {
                  this.turns.remove (oldIndex);
               }
               if (oldValue != value)
               {
                  if (oldValue != null)
                  {
                     oldValue.setWizardGame (null);
                  }
                  if (oldIndex < 0)
                  {
                     value.setWizardGame (this);
                  }
                  changed = true;
               }
            
            }
            catch (IndexOutOfBoundsException ex)
            {
               return false;
            }
         }
      }
      return changed;
   }

   @Property( name = PROPERTY_TURNS )
   public boolean removeFromTurns (int index)
   {
      boolean changed = false;

      if (this.turns != null && (index >= 0 && index < this.turns.size ()))
      {
      
         Turn tmpValue = (Turn) this.turns.remove (index);
         if (tmpValue != null)
         {
            tmpValue.setWizardGame (null);
            changed = true;
         }
      
      }
      return changed;
   }

   @Property( name = PROPERTY_TURNS )
   public boolean removeFromTurns (int index, Turn value)
   {
      boolean changed = false;

      if ((this.turns != null) && (value != null) && 
          (index >= 0 && index < this.turns.size ()))
      {
         Turn oldValue = (Turn) this.turns.get (index);
         if (oldValue == value)
         {
         
            changed = this.removeFromTurns (index);
         
         }
      }
      return changed;
   }

   @Property( name = PROPERTY_TURNS )
   public ListIterator<? extends Turn> iteratorOfTurns ( Turn  lowerBound )
   {
      ListIterator<Turn> result = FEmptyListIterator.<Turn>get ();

      if (turns != null && lowerBound != null)
      {
         int index = turns.indexOf (lowerBound) + 1;
         result = turns.listIterator (index);
      }
      else if (turns != null && lowerBound == null)
      {
         result = turns.listIterator (0);
      }

      return result;
   }

   @Property( name = PROPERTY_TURNS )
   public ListIterator<? extends Turn> iteratorOfTurns (int index)
   {
      return ((this.turns == null)
              ? FEmptyListIterator.<Turn>get ()
              : this.turns.listIterator (Math.max(0,Math.min(index,this.turns.size ()))));
   }

   /**
    * <pre>
    *           0..1     winner     0..1
    * WizardGame ------------------------- Player
    *           winnerRev               winner
    * </pre>
    */
   public static final String PROPERTY_WINNER = "winner";

   @Property( name = PROPERTY_WINNER, partner = Player.PROPERTY_WINNER_REV, kind = ReferenceHandler.ReferenceKind.TO_ONE,
         adornment = ReferenceHandler.Adornment.NONE)
   private Player winner;

   @Property( name = PROPERTY_WINNER )
   public boolean setWinner (Player value)
   {
      boolean changed = false;

      if (this.winner != value)
      {
      
         Player oldValue = this.winner;
         WizardGame source = this;
         if (this.winner != null)
         {
            this.winner = null;
            oldValue.setWinnerRev (null);
         }
         this.winner = value;

         if (value != null)
         {
            value.setWinnerRev (this);
         }
         changed = true;
      
      }
      return changed;
   }

   @Property( name = PROPERTY_WINNER )
   public WizardGame withWinner (Player value)
   {
      setWinner (value);
      return this;
   }

   public Player getWinner ()
   {
      return this.winner;
   }

   public void removeYou()
   {
      this.setClosedStack (null);
      this.setCurrentPlayer (null);
      this.setCurrentTurn (null);
      this.setOpenStack (null);
      this.removeAllFromPlayers ();
      this.removeAllFromTurns ();
      this.setWinner (null);
   }
}


